jQuery(document).ready(function($){
	
	//file
	var uploaderForFile;
	buttonForFile = '.f70ldd_upload_button';
	
	$( buttonForFile ).click(function(e) {
		e.preventDefault();
		clickedButton = $(this);
		rowNum = clickedButton.data('row-num');
		
		//If the uploader object has already been created, reopen the dialog
		if ( uploaderForFile ) {
			uploaderForFile.open();
			return;
		}
		
		//Extend the wp.media object
		uploaderForFile = wp.media.frames.file_frame = wp.media({
			title: f70LeadDocumentDownload.chooseFile,
			button: {
				text: f70LeadDocumentDownload.chooseFile
			},
			multiple: false
		});
		//console.log(uploaderForFile);
		
		//When a file is selected, grab the URL and set it as the text field's value
		uploaderForFile.on( 'select', function() {
			attachment = uploaderForFile.state().get('selection').first().toJSON();
			
			$( '#f70ldd_download_file_id_' + rowNum ).val( attachment.id );
			$( '#f70ldd_download_file_field_' + rowNum + ' span' ).text( attachment.name );
			$( '.f70ldd_filelink_' + rowNum ).val( attachment.link );
		});
		//Open the uploader dialog
		uploaderForFile.open();
	});
	
	//Thumbnail
	var uploaderForThumbnail;
	buttonForThumbnail = '.f70ldd_upload_thumbnail_button';
	$( buttonForThumbnail ).click(function(e) {
		e.preventDefault();
		clickedButton = $(this);
		rowNum = clickedButton.data('row-num');
		
		//If the uploader object has already been created, reopen the dialog
		if ( uploaderForThumbnail ) {
			uploaderForThumbnail.open();
			return;
		}
		//Extend the wp.media object
		uploaderForThumbnail = wp.media.frames.file_frame = wp.media({
			title: f70LeadDocumentDownload.chooseThumbnail,
			button: {
				text: f70LeadDocumentDownload.chooseThumbnail
			},
			multiple: true
		});
		//When a file is selected, grab the URL and set it as the text field's value
		uploaderForThumbnail.on('select', function() {
			attachment = uploaderForThumbnail.state().get('selection').first().toJSON();
			//console.log(attachment);
			
			$( '#f70ldd_download_thumbnail_id_' + rowNum ).val( attachment.id );
			$( '#thumbnail_preview_' + rowNum ).html('<img src="' + attachment.url + '">');
			
		});
		//Open the uploader dialog
		uploaderForThumbnail.open();
	});
	
	
	//delete button
	$('.f70ldd_delete_button').click(function(e) {
		e.preventDefault();
		rowNum = $(this).data('row-num');
		targetArea = $(this).data('area');
		
		//console.log( '#f70ldd_download_file_field_' + rowNum + ' .' + targetArea + ' input[type="text"]');
		$( '#f70ldd_download_file_field_' + rowNum + ' .' + targetArea + ' input[type="text"]' ).val('');
		$( '#f70ldd_download_file_field_' + rowNum + ' .' + targetArea + ' input[type="hidden"]' ).val('');
		$( '#f70ldd_download_file_field_' + rowNum + ' .' + targetArea + ' span' ).text('');
		$( '#f70ldd_download_file_field_' + rowNum + ' .' + targetArea + ' .thumbnail_preview' ).html('');
		
	});
});