<?php
/*
Plugin Name:	F70 Lead Document Download
Plugin URI:	https://factory70.com/lead-document-download
Description:	This plugin allows you to create document download forms. Visitors fill out the form and recieve the email with URL to download. You can easily provide a simple lead generation system.
Author:	Nao Matsuo
Version:	1.0.3
Author URI:	https://factory70.com
License:	GPL v2 or later
License URI:	https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: f70-lead-document-download
*/

if ( !function_exists( 'add_action' ) ) {
	//echo 'Hi there!  I\'m just a plugin, not much I can do when called directly.';
	exit;
}

class f70LeadDocumentDownload{
	public function __construct	() {
		define( 'F70_LDD__PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
		define( 'F70_LDD__PLUGIN_DIR_URL', plugins_url( '', __FILE__ ) );
		define( 'F70_LDD__PLUGIN_FILE', __FILE__);
		define( 'F70_LDD__COOKIE_NAME', 'nmcVisitedHome');
		define( 'F70_LDD__DB_VERSION', '1.1');
		
		define( 'F70_LDD__FILE_SETS', '3');//1フォームに登録できる書類数
		define( 'F70_LDD__POST_TYPE', 'f70_lead_document');//書類フォームの投稿タイプ
		define( 'F70_LDD__DL_PALAM_NAME', 'f70ldd_download');//ダウンロードページを呼び出すパラメータ名
		
		define( 'F70_LDD__DONWLOAD_PAGE_ID_OP', 'f70ldd_download_page_id');//ダウンロードページのIDのoption名
		define( 'F70_LDD__DONWLOAD_PAGE_SLUG', 'f70ldd_download_page');
		
		define( 'F70_LDD__SAMPLE_FORM_ID', 'f70ldd_sample_form_id');//サンプルフォームのIDのoption名
		
		global $wpdb;
		define( 'F70_LDD__DB_TABLE_NAME_LIST', $wpdb->prefix.'f70ldd_entry_list');//データベース名
		
		
		//----------------
		
		require_once( F70_LDD__PLUGIN_DIR . 'includes/class.functions.php' );
		new f70LddFunctions();
		
		require_once( F70_LDD__PLUGIN_DIR . 'includes/class.setup.php' );
		new f70LddSetup();
		
		require_once( F70_LDD__PLUGIN_DIR . 'includes/class.entry.php' );
		new f70LddEntry();
		
		require_once( F70_LDD__PLUGIN_DIR . 'includes/class.download.php' );
		new f70LddDownload();
		
		require_once( F70_LDD__PLUGIN_DIR . 'includes/class.shortcodes.php' );
		new f70LddShortcodes();
		
		
		if( is_admin() || ( defined( 'WP_CLI' ) && WP_CLI ) ){
			require_once( F70_LDD__PLUGIN_DIR . 'includes/class.admin.php' );
			new f70LddAdmin();
			
			require_once( F70_LDD__PLUGIN_DIR . 'includes/class.form.php' );
			new f70LddForm();
			
			require_once( F70_LDD__PLUGIN_DIR . 'includes/class.upload_directory.php' );
			new f70LddUploadDirectory();
			
		}
	}
}
new f70LeadDocumentDownload();



//ルート
if ( ! function_exists( 'f70Ldd_after_setup_theme_action' ) ) {

	function f70Ldd_after_setup_theme_action() {
		add_action( 'template_redirect', 'f70Ldd_template_redirect_action' );
		
	}
	
	function f70Ldd_template_redirect_action() {
		
		//排除用Cookie削除 - 管理者のみ
		if( isset($_GET['f70ldd_delete_cookie']) ){
			if( ( $_GET['f70ldd_delete_cookie']) && ( current_user_can('manage_options') )  ){
				f70LddEntry::delete_reject_cookie();
				wp_redirect( get_permalink() );
				exit;
			}
		}
		
		
		//ダウンロード登録:リロード対策,セッション起動
		if ( has_shortcode( get_the_content(), 'f70ldd_entry_form' ) ) { 
			f70LddEntry::start_session();
			//print_r( $_SESSION );
			
			if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {
				if ( 
					!empty( $_SESSION[ 'accept_code' ] )
					&& ( $_SESSION[ 'accept_code' ] == 1 )
				) {
					f70LddEntry::end_session();
				}
			}
		}
		
		
		
		if( get_post_type() === F70_LDD__POST_TYPE ) {
			add_filter( 'the_content', array( 'f70LddShortcodes', 'display_entry_form') );
		}
		/*
		if( isset($_GET[ F70_LDD__DL_PALAM_NAME ]) ){
			require_once( F70_LDD__PLUGIN_DIR . 'includes/class.download.php' );
			$cls_dl = new f70LddDownload();
			add_filter( 'the_content', array( 'f70LddDownload', 'display_download') );
		}
		*/
		
		
	}
}
add_action( 'after_setup_theme', 'f70Ldd_after_setup_theme_action' );


?>