<?php
//全体の設定ページ
if( !class_exists( 'f70LddAdmin' ) ){
class f70LddAdmin{
	
	private $file_sets = F70_LDD__FILE_SETS;
	
	public function __construct(){
		add_action( 'admin_menu', array($this, 'register_setting_page' ));
		add_action( 'admin_init', array($this, 'register_settings' ));
		add_action( 'admin_init', array($this, 'add_settings_sections' ));
		add_action( 'admin_init', array($this, 'add_settings_fields' ));
		add_action( 'admin_init', array($this, 'enqueue_js' ));
		add_action( 'admin_init', array($this, 'enqueue_style' ));
		
		//デフォルト値アップデート
		add_action( 'admin_init', array($this, 'update_email_template' ));
		add_action( 'admin_init', array($this, 'update_download_number_limit' ));
	}
	
	public function enqueue_js(){
		wp_enqueue_media();
		
		//ファイルアップローダjs 個別設定(form)で使用
		wp_register_script( 'f70ldd-admin-js', F70_LDD__PLUGIN_DIR_URL . '/assets/js/admin.js', array('jquery') );
			//jsの翻訳対応
		$translation_array = array(
			'chooseFile'	=>	__( 'Choose File' ),
			'chooseThumbnail'	=>	__( 'Choose Thumbnail' ),
		);
		wp_localize_script( 'f70ldd-admin-js', 'f70LeadDocumentDownload', $translation_array );
		wp_enqueue_script( 'f70ldd-admin-js' );
	}
	public function enqueue_style(){
		wp_register_style( 'f70ldd-admin', F70_LDD__PLUGIN_DIR_URL . '/assets/css/admin.css' );
		wp_enqueue_style( 'f70ldd-admin' );
	}
	
	public function register_setting_page(){
		add_menu_page(
			__( 'F70 Lead Document Download', 'f70-lead-document-download' ),
			__( 'Download Forms', 'f70-lead-document-download' ),//
			'manage_options',
			'f70ldd-setting-admin',//page
			array( $this, 'settings_view' ),
			''
			//10
		);
		
		//設定サブメニュー（名前コントロールのため）
		add_submenu_page(
			'f70ldd-setting-admin',//$parent_slug,
			__( 'F70 Lead Document Download Settings', 'f70-lead-document-download' ),//'設定',//string $page_title,
			__( 'Settings', 'f70-lead-document-download' ),//'設定',//string $menu_title,
			'manage_options',//string $capability,
			'f70ldd-setting-admin', //$parent_slug と同じにする,
			//array($this, 'my_function')//callable $function = '',
			//,//int $position = null )
		);
		
		//フォーム一覧
		add_submenu_page(
			'f70ldd-setting-admin',//$parent_slug,
			__( 'Forms', 'f70-lead-document-download' ),//'一覧',//string $page_title,
			__( 'Form', 'f70-lead-document-download' ),//'フォーム',//string $menu_title,
			'manage_options',//string $capability,
			'edit.php?post_type=' . F70_LDD__POST_TYPE//string $menu_slug,
			//array($this, 'my_function')//callable $function = '',
			//,//int $position = null )
		);
	}
	
	public function settings_view(){
		include( F70_LDD__PLUGIN_DIR . 'views/settings.php' );
	}
	
	
	public function register_settings(){
		//設定登録
		/*
			送信元メールアドレス
			差出人名
			メール本文（客用）、メール本文（自分へのお知らせ用）
			メールのタイトルにフォームタイトルを入れるかどうか
			//メールタイトルのサンプル（設定ではない）
			
			最大ダウンロード回数
			
		*/
		//register_setting( 'f70ldd_settings_group', 'f70ldd_download_num' );
		
		register_setting( 'f70ldd_settings_group', 'f70ldd_email_from' );
		register_setting( 'f70ldd_settings_group', 'f70ldd_email_sender_name' );
		register_setting( 'f70ldd_settings_group', 'f70ldd_email_body_to_user' );
		register_setting( 'f70ldd_settings_group', 'f70ldd_email_body_to_admin' );
		register_setting( 'f70ldd_settings_group', 'f70ldd_email_subject_form_title' );
		register_setting( 'f70ldd_settings_group', 'f70ldd_download_number_limit' );
		
	}
	public function add_settings_sections(){
		//設定セクション
			
		
		//あとで使うので残しておいて
		/*
		add_settings_section(
			'f70ldd_setting_section_form', // ID
			__( 'Form settings', 'f70-lead-document-download' ),//'フォームの設定', // Title
			array($this, 'print_section_info'), // Callback
			'f70ldd-setting-admin' // Page
		);
		*/
		add_settings_section(
			'f70ldd_setting_section_mail', // ID
			__( 'Email settings', 'f70-lead-document-download' ),//'メールの設定', // Title
			'', //array($this, 'print_section_info'), //タイトルの下に表示される
			'f70ldd-setting-admin' // Page
		);
		add_settings_section(
			'f70ldd_setting_section_download', // ID
			__( 'Download settings', 'f70-lead-document-download' ),//'ダウンロードの設定', // Title
			'',//array($this, 'print_section_info'), // Callback
			'f70ldd-setting-admin' // Page
		);
	}
	public function add_settings_fields(){
		//入力欄一覧
		$setting_page = 'f70ldd-setting-admin';
		
		//送信元メールアドレス
		add_settings_field(
			'f70ldd_email_from',
			__( 'Email from', 'f70-lead-document-download' ),//'送信元メールアドレス',
			array($this, 'display_form'),
			$setting_page,
			'f70ldd_setting_section_mail',
			array(
				'id'	=>	'f70ldd_email_from',
				'form_type'	=>	'email',
				'description'	=>	__( 'If you leave this blank, WordPress admin email will be used.', 'f70-lead-document-download' ),
			)
		);
		
		//差出人名
		add_settings_field(
			'f70ldd_email_sender_name',
			__( 'Email sender name', 'f70-lead-document-download' ),
			array($this, 'display_form'),
			$setting_page,
			'f70ldd_setting_section_mail',
			array(
				'id'	=>	'f70ldd_email_sender_name',
				'form_type'	=>	'text',
				'description'	=>	__( 'If you leave this blank, the site name will be used.', 'f70-lead-document-download' ),
			)
		);
		
		//メール本文
		
		add_settings_field(
			'f70ldd_email_body_to_user',
			__( 'Email body template (to customer)', 'f70-lead-document-download' ), //'メール本文(訪問者へ)',
			array($this, 'display_form'),
			$setting_page,
			'f70ldd_setting_section_mail',
			array(
				'id' => 'f70ldd_email_body_to_user',
				'form_type'	=>	'textarea',
				'description'	=>	__( 'This must include [download_url].', 'f70-lead-document-download' ),
			)
		);
		
		add_settings_field(
			'f70ldd_email_body_to_admin',
			__( 'Email body template (to admin)', 'f70-lead-document-download' ), //'メール本文(管理者へ)',
			array($this, 'display_form'),
			$setting_page,
			'f70ldd_setting_section_mail',
			array(
				'id' => 'f70ldd_email_body_to_admin',
				'form_type'	=>	'textarea',
				'description'	=>	__( 'It is not recommended to change this.', 'f70-lead-document-download' ),
			)
		);
		
		
		//ダウンロード回数
		add_settings_field(
			'f70ldd_download_number_limit',
			__( 'Number of downloads per email', 'f70-lead-document-download' ),
			array( $this, 'display_form_for_downlaad_number_limit' ), //array( $this, 'display_form' ),
			$setting_page,
			'f70ldd_setting_section_download',
			array(
				'id'	=>	'f70ldd_download_number_limit',
				'form_type'	=>	'select',
			)
		);
		
	}
	
	
	
	//---------入力欄出力
	public function display_form( array $args ){
		if( isset($args['id']) ){
			$id = $args['id'];
			$value = esc_attr( get_option( $args['id'] ) );
		}else{
			$id = '';
			$value = '';
		}
		if( isset($args['form_type']) ){
			if( $args['form_type'] == 'textarea' ){
				echo '<textarea name="'.$id.'" id="'.$id.'">'.$value.'</textarea>';
			}else{
				echo '<input type="'.$args['form_type'].'" name="'.$id.'" id="'.$id.'" value="'.$value.'">';
			}
		}else{
			echo '<span>form_type is not specified.</span>';
		}
		if( isset( $args['description'] ) ){
			echo '<span class="description">'.$args['description'].'</span>';
		}
	}
	
	
	public function display_form_for_downlaad_number_limit( array $args ){
		//ダウンロード回数用のフォーム（option）
		if( isset($args['id']) ){
			$id = $args['id'];
			$value = esc_attr( get_option( $args['id'] ) );
		}else{
			$id = '';
			$value = '';
		}
		
		$selected_unlimited = '';
		if ( empty( $value ) ) {
			$selected_unlimited = ' selected';
		}
		
		echo '<select name="' . $id . '" id="' . $id . '">';
		echo '<option value="unlimited"' . $selected_unlimited . '>' . __( 'Unlimited', 'f70-lead-document-download' ) . '</option>';
		
		for ( $i = 1; $i <= 10; $i++ ) {
			$selected = '';
			if ( !empty( $value ) && ( $value == $i ) ) {
				$selected = ' selected';
			}
			echo '<option value="' . $i . '"' . $selected . '>' . $i . '</option>';
		}
		
		echo '</select>';
		
		if( isset( $args['description'] ) ){
			echo '<span class="description">'.$args['description'].'</span>';
		}
	}
	
	
	
	
	public function update_email_template() {
		//メールテンプレートにデフォルト設定を書き込む
		/*設定が空の場合にviewから取ってきて入力*/
		
		$to_strs = array( 'to_user', 'to_admin' );
		foreach ( $to_strs as $to ) {
			$option_name = 'f70ldd_email_body_' . $to;
			if ( empty( get_option( $option_name ) ) ) {
				$file = F70_LDD__PLUGIN_DIR . 'views/email_' . $to . '.php';
				if ( file_exists( $file ) ) {
					ob_start();
					include_once( $file );
					$str = ob_get_contents();
					ob_end_clean();
				}
				
				if ( !empty( $str ) ) {
					update_option( $option_name, $str );
				}
			}
		}
	}
	
	
	public function update_download_number_limit() {
		//ダウンロード制限回数にデフォルト設定を書き込む
		/*設定が空の場合 6に設定*/
		$num = get_option( 'f70ldd_download_number_limit' );
		if ( empty( $num ) ) {
			update_option( 'f70ldd_download_number_limit', 6 );
		}
	}
	
	
//----
}
}
?>