<?php
if( !class_exists( 'f70LddEntry' ) ) {
class f70LddEntry {
	
	private $entry_page_id;
	/*
	public function __construct() {
		
	}
	*/
	
	public static function start_session() {
		//セッション開始//プラグイントップから呼び出すこと。
		if ( !isset( $_SESSION ) ) {
			@session_name('f70ldd_entry');
			session_start();
			$_SESSION['f70ldd_entry_session'] = session_id();
		}
	}
	public static function end_session() {
		//セッション終了//プラグイントップから呼び出すこと。
		if ( !isset($_SESSION) ) {
			return;
		}
		//受付コードをチェック
		if( isset( $_SESSION[ 'accept_code' ] ) ) {
			if( $_SESSION[ 'accept_code' ] == 2 ) {
				//NG属性がついてた場合
				f70LddEntry::set_reject_cookie();
				unset( $_SESSION['accept_code'] );
				unset( $_SESSION );
				setcookie( 'f70ldd_entry', '', time() - 600, '/' );
				
			} elseif( $_SESSION[ 'accept_code' ] == 1 ) {
				//正常終了されていた場合
				if( isset( $_SESSION['f70ldd_entry_session'] ) ) {
					unset( $_SESSION['f70ldd_entry_session'] );
				}
				unset( $_SESSION['accept_code'] );
				unset( $_SESSION );
				setcookie( 'f70ldd_entry', '', time() - 600, '/' );
				@session_destroy();//いらんのでは？
			}
		}
	}
	
	
	
	
	public static function entry_form_accept() {
		//-----フォームを受け取った時の処理
		
		//リロード対策
		if ( $_SERVER['REQUEST_METHOD'] == 'POST' ) {
			if (
				!empty( $_SESSION['f70ldd_entry_session'] )
				 && ( $_POST['session_id'] != $_SESSION['f70ldd_entry_session'] )
			) {
				return;
			}
			if ( !empty( $_SESSION['accept_code'] ) && ( $_SESSION['accept_code'] == 1 ) ) {
				return;
			}
		}
		
		
		$data = array();
		$data['errors'] = array();
		$err_str_noinput = __( 'Please fill the field.', 'f70-lead-document-download' ); //ご記入ください。'
		
		$post_data = f70LddEntry::check_post_data();//$_POSTの直後チェック
		if ( empty( $post_data ) ) { return; }
		$form_settings = f70LddFunctions::get_form_settings( $post_data[ 'ldd_setting_id' ] );
		
		//cookieはここでは食えない。
		
		//NGチェック / 職業NG、捨てアドなどの場合 / 再度クッキーチェック(戻り防止)
		if (
			( f70LddEntry::ng_check( $post_data, $form_settings ) == 'ng' )
			or ( f70LddEntry::cookie_reject_check() == 'ng' )
		) {
			$_SESSION['accept_code'] = 2;
			//cookie付与はviewにて(js)
			$data['view'] = 'entry_ng';
			return $data;
		}
		
		
		//---値チェック
		$check_errors = false;
		// -属性
		if ( !empty( $form_settings[ 'attribute_list' ] ) ) {
			if ( empty( $post_data[ 'attribute' ] ) ) {
				$check_errors = true;
				$data['attribute']['errors'][] = $err_str_noinput;
			} else {
				$data['attribute']['value']	=	isset( $post_data['attribute'] ) ? $post_data['attribute'] : '';
				$data['attribute']['title']	=	isset( $post_data['attribute_title'] ) ? $post_data['attribute_title'] : '';
			}
		}
		// -メールアドレス
		if ( empty( $post_data[ 'email' ] ) ) {
			$check_errors = true;
			$data['email']['errors'][] = $err_str_noinput;
		} else {
			$data['email'] = f70LddEntry::check_email( $post_data['email'] );
			if ( !empty( $data['email']['errors'] ) ) {
				$check_errors = true;
			}
		}
		// -テキスト入力欄
		foreach ( $form_settings[ 'input_text_forms' ] as $key => $val ) {
			if ( empty( $post_data[ $key ] ) ) {
				$data[ $key ][ 'errors' ][] = $err_str_noinput;
				$check_errors = true;
			} else {
				$data[ $key ][ 'title' ] = $post_data[ $key . '_title' ];
				$data[ $key ][ 'value' ] = $post_data[ $key ];
			}
		}
		
		//入力内容に問題がある場合->差し戻し
		if ( $check_errors == true ) {
			$data['error'] = true;
			$data['view'] = 'entry';
			$data['errors'][] = __( 'Please correct the input and click the submit button again.', 'f70-lead-document-download' ); //'入力内容を修正して再度送信ボタンを押してください。'
			return $data;
			
			
		} else {
			//チェック問題なければ
			
			//キーの発行
			$data['dlkey'] = f70LddFunctions::make_dlkey(24);
			$data['url'] = f70LddEntry::make_dlurl( $data['dlkey'] );
			
			$data['form_id'] = $post_data['ldd_setting_id'];
			
			//データ保存
			if ( f70LddEntry::save($data) ) {
				//メール送信
				$eml1 = f70LddEntry::send_email('to_user', $data);
				$eml2 = f70LddEntry::send_email('to_admin', $data);
				
				if ( $eml1 && $eml2 ) {
					//完了画面へ
					$data['view'] = 'accepted';
					$_SESSION['accept_code'] = 1;
					return $data;
				} else {
					$data['errors'][] = __( 'Failed to send the email. Click the submit button again.', 'f70-lead-document-download' ); //'メールの送信に失敗しました。もう一度送信ボタンを押してください。'
					return $data;
				}
			} else {
				$data['errors'][] = __( 'Failed to save the data. Click the submit button again.', 'f70-lead-document-download' ); //'データの保存に失敗しました。もう一度送信ボタンを押してください。'
				return $data;
			}
		}
	}
	
	
	static function check_post_data() {
		//$_POSTの直後チェック
		$data = array();
		$post_data  = filter_input_array( INPUT_POST, FILTER_SANITIZE_STRING );
		
		foreach ( $post_data as $key => $val ) {
			if ( !empty( $val ) ) {
				if( $key === 'email' ) {
					$val = sanitize_email( $val );
				} else {
					$val = sanitize_text_field( $val );
				}
				$data[ $key ] = $val;
			}
		}
		
		return $data;
	}
	
	
	static function ng_check( $post_data, $form_settings ) {
		//NG、捨てアド、スパムのチェック
		$check = 'ok';
		
		//emailのチェック//捨てアドなどをチェック※未実装
		
		//属性のNGチェック
		if ( !empty( $post_data[ 'attribute' ] ) ) {
			
			if ( !empty( $form_settings['ng_attribute_list'] ) ) {
				//NG属性のりすとが設定されていればチェック
				$atts_ng = $form_settings['ng_attribute_list'];
				foreach ( $atts_ng as $att_ng ) {
					if ( $att_ng == $post_data[ 'attribute' ] ) {
						$check = 'ng';
						break;
					}
				}
			}
		}
		return $check;
	}
	
	static function check_email( $val = '' ) {
		//いらんかも。
		//emailの書式チェック //NGチェックはこの時点で済んでいる
		$ret = array();
		$errors = array();
		
		if ( empty($val) ) {
			$errors[] = __( 'Input this field.', 'f70-lead-document-download' ); //'入力してください'
		} else {
			if ( !preg_match('/^([a-z0-9\+_\-\.\(\)\^\=\*\&\%\#\!]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/i', $val) ) {
				$errors[] = __( 'Please input correct email address.', 'f70-lead-document-download' ); //'メールアドレスを正しく記入してください'
			}
		}
		
		$ret['errors'] = $errors;
		$ret['value'] = $val;
		return $ret;
	}
	
	
	static function check_email_duplicate( $email = '', $days = 3 ) {
		//email重複チェック
	}
	
	
	static function check_str( $val = '' ) {
		//文字列のチェック
		$ret = array();
		$errors = array();
		
		if ( empty($val) ) {
			$errors[] = __( 'Input this field.', 'f70-lead-document-download' ); //'入力してください'
		}
		
		$ret['errors'] = $errors;
		$ret['value'] = $val;
		return $ret;
	}
	
	static public function str_to_rtrim_array( $str ) {
		//空白削除して配列化
		$array1 = explode("\n", $str);
		$array2 = array();
		foreach ( $array1 as $elm ) {
			$array2[] = rtrim($elm);
		}
		return $array2;
	}
	
	
	//------受付後の処理
	
	static public function make_dlurl( $key ) {
		//ダウンロードURLの作成
		$base = get_permalink( get_option( F70_LDD__DONWLOAD_PAGE_ID_OP ) );
		$pos = strpos( $base, '?page_id=' );
		if ( $pos !== false ) {
			return $base . '&' . F70_LDD__DL_PALAM_NAME . '=' . $key;
		} else {
			return $base . '?' . F70_LDD__DL_PALAM_NAME . '=' . $key;
		}
	}
	
	
	static public function save( $data ) {
		//データ保存
		global $wpdb;
		
		//メールアドレス->すでに登録されているか
		$exists = $wpdb->get_results(
			$wpdb->prepare( "SELECT ID FROM " . F70_LDD__DB_TABLE_NAME_LIST . " WHERE email = %s", $data['email']['value'] )
		);
		
		$insert = array(
			'time'	=>	current_time( 'mysql' ),
			'email'	=>	$data['email']['value'],
			'dlkey'	=>	$data['dlkey'],
			'count'	=>	0,
			'formid'	=>	$data['form_id'],
		);
		
		if ( count($exists) > 0 ) {
			//あれば上書き
			//あれば上書きでなくて、最近の登録だったら排除にしたい。
			$i = $wpdb->update(
				F70_LDD__DB_TABLE_NAME_LIST,
				$insert,
				array(
					'ID' => $exists[0]->ID,
				)
			);
		
		} else {
			//なければ新規
			$i = $wpdb->insert(
				F70_LDD__DB_TABLE_NAME_LIST,
				$insert
			);
		}
		if ( $i > 0 ) {
			return true;
		} else {
			return false;
		}
	}
	static public function send_email( $to_str = '', $data ) {
		//メール送信
		return wp_mail(
			f70LddEntry::get_email_to( $to_str, $data ),
			f70LddEntry::email_subject( $to_str ),
			f70LddEntry::mail_body( $to_str, $data ),
			f70LddEntry::email_header()
		);
	}
	
	static public function get_email_to( $to_str = '', $data ) {
		//メール送信先
		if ( $to_str == 'to_user' ) {
			return $data['email']['value'];
		} else {
			if ( get_option( 'admin_email' ) ) {
				return get_option( 'admin_email' );
			}
		}
	}
	static public function get_mail_body_template( $to = '' ) {
		//メール本文の取得
		$default = get_option( 'f70ldd_email_body_' . $to );
		if ( !empty( $default ) ) {
			return $default;
		} else {
			$file = F70_LDD__PLUGIN_DIR . 'views/email_' . $to . '.php';
			if ( file_exists( $file ) ) {
				ob_start();
				include_once( $file );
				$str = ob_get_contents();
				ob_end_clean();
				return $str;
			} else {
				return false;
			}
		}
	}
	static public function mail_body( $to_str = '', $data ) {
		//メール本文作成 / データ置き換え
		$body = f70LddEntry::get_mail_body_template( $to_str );
		
		$replaces = array(
			'[email]'	=>	isset( $data['email']['value'] ) ? $data['email']['value'] : '',
			'[download_url]'	=>	$data['url'],
			'[dlkey]'	=>	$data['dlkey'],
			'[company]'	=>	isset( $data['company']['value'] ) ? $data['company']['value'] : '',
			'[fullname]'	=>	isset( $data['fullname']['value'] ) ? $data['fullname']['value'] : '',
			'[region]'	=>	isset( $data['region']['value'] ) ? $data['region']['value'] : '',
			'[attribute]'	=>	isset( $data['attribute']['value'] ) ? $data['attribute']['value'] : '',
			'[sitename]'	=>	get_option( 'blogname' ),
			'[siteurl]'	=>	home_url(),
			
			'[attribute_title]'	=>	$data['attribute']['title'],
			'[region_title]'	=>	isset( $data['region']['title'] ) ? $data['region']['title'] : __( 'Region', 'f70-lead-document-download' ), //地域
			'[fullname_title]'	=>	isset( $data['fullname']['title'] ) ? $data['fullname']['title'] : __( 'Name', 'f70-lead-document-download' ), //氏名
			'[company_title]'	=>	isset( $data['company']['title'] ) ? $data['company']['title'] : __( 'Company Name', 'f70-lead-document-download' ), //社名
			
			'[download_limit_number]'	=>	get_option( 'f70ldd_download_number_limit', '6' ),
			
		);
		
		//宛名の作成 // 社名はなしにしよう
		$fullname = isset( $data['fullname']['value'] ) ? $data['fullname']['value'] : '';
		$name_str = sprintf( __( 'Dear %s:', 'f70-lead-document-download' ), $fullname );//〜様
		//error_log( print_r( 'name_str->' . $name_str, true ) );
		
		if ( !empty( $name_str ) ) {
			$replaces['[name_str]'] = $name_str;
		}
		
		
		$body = str_replace( array_keys($replaces), array_values($replaces), $body );
		return $body;
	}
	
	static public function email_header(){
		//メール送信元の作成
		
		//送信元メール default=wp admin_email
		$mail_from = get_option( 'admin_email' );
		$email_from_plugin_option = get_option( 'f70ldd_email_from' );
		if ( !empty( $email_from_plugin_option ) ) {
			$mail_from = $email_from_plugin_option;
		}
/* elseif ( get_option( 'admin_email' ) ) {
			$mail_from = get_option( 'admin_email' );
		}*/
		
		//送信者名
		$name_from = get_option( 'blogname' );
		$name_from_plugin_option = get_option( 'f70ldd_email_sender_name' );
		if ( !empty( $name_from_plugin_option ) ) {
			$name_from = $name_from_plugin_option;
		}
		
		
		if ( !empty($name_from) ) {
			$str = 'From: '.$name_from.' <'.$mail_from.'>';
		} else {
			$str = 'From: '.$mail_from;
		}
		return $str;
	}
	static public function email_subject( $to_str = '' ) {
		//メール件名
		
		//if ( get_option( 'f70ldd_email_subject_'.$to_str ) ) {
			//return get_option( 'f70ldd_email_subject_'.$to_str );
		//} else {
			$str = __( 'Your download link', 'f70-lead-document-download' ); //'ダウンロードURLのお知らせ'
			if ( $to_str == 'to_admin' ) {
				$str = __( 'Download user has registered', 'f70-lead-document-download' ); //'ダウンロード登録がありました'
			}
			//メールのタイトルにフォーム名を入れる場合、追加//未作成
			
			//サイト名追加
			if ( get_option( 'blogname' ) ) {
				$str .= ' ['.get_option( 'blogname' ).']';
			}
			return $str;
		//}
	}
	
	
	
	//-----クッキー関連
	//排除クッキーのチェック
	static public function cookie_reject_check() {
		$check = 'ok';
		if ( isset($_COOKIE[F70_LDD__COOKIE_NAME]) ) {
			if( $_COOKIE[F70_LDD__COOKIE_NAME] == 'true' ) {
				$check = 'ng';
			}
		}
		return $check;
	}
	//排除クッキーの削除/after_setup_themeから呼び出し
	static public function delete_reject_cookie() {
		setcookie( F70_LDD__COOKIE_NAME, '', time() - 600, '/' );
		setcookie( 'f70ldd_entry', '', time() - 600, '/' );
	}
	

//----
}
}
?>