<?php
//フォームの設定ページ
if( !class_exists( 'f70LddForm' ) ){
class f70LddForm{
	
	public function __construct() {
		add_action( 'add_meta_boxes', array( $this, 'add_meta_box' ));
		add_action( 'save_post', array( $this, 'save' ) );
	}
	
	
	//-------metabox設置
	public function add_meta_box( $post_type ) {
		
		if ( $post_type !== F70_LDD__POST_TYPE ) {
			return;
		}
		
		//metabox ショートコードサンプル
		add_meta_box(
			'f70ldd_meta_box_display_shortcode',
			__( 'Shortcode', 'f70-lead-document-download' ),
			array( $this, 'render_meta_box_shortcode' ),
			$post_type,
			'advanced',
			'high'
		);
		
		//metabox フォームの設定
		add_meta_box(
			'f70ldd_meta_box_form',
			__( 'Form', 'f70-lead-document-download' ),
			array( $this, 'render_meta_box_form_settings' ),
			$post_type,
			'advanced',
			'high'
		);
		
		//metabox メールの設定//使ってない
		/*
		add_meta_box(
			'f70ldd_meta_box_email',
			__( 'Email', 'f70-lead-document-download' ),
			array( $this, 'render_meta_box_email_settings' ),
			$post_type,
			'advanced',
			'high'
		);
		*/
		
		//metabox ファイルの設定
		add_meta_box(
			'f70ldd_meta_box_download',
			__( 'Files', 'f70-lead-document-download' ),
			array( $this, 'render_meta_box_download_settings' ),
			$post_type,
			'advanced',
			'high'
		);
	
	}
	
	
	public function save( $post_id ) {
		//保存
		
		if ( ! isset( $_POST['f70ldd_edit_document_nonce'] ) ) {
			return $post_id;
		}
		
		// Verify that the nonce is valid.
		if ( ! wp_verify_nonce( $_POST['f70ldd_edit_document_nonce'], 'f70ldd_edit_document' ) ) {
			return $post_id;
		}
		
		// If this is an autosave, our form has not been submitted,
		//     so we don't want to do anything.
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
			return $post_id;
		}
		
		// Check the user's permissions.
		if ( F70_LDD__POST_TYPE == $_POST['post_type'] ) {
			if ( ! current_user_can( 'edit_post', $post_id ) ) {
				return $post_id;
			}
		} else {
			return $post_id;
		}
		
		/* OK, its safe for us to save the data now. */
		
		// Sanitize the user input.
		//$mydata = sanitize_text_field( $_POST['myplugin_new_field'] );
		
		// Update the meta field.
		//update_post_meta( $post_id, '_my_meta_value_key', $mydata );
		//print_r($_POST);
		
		
		$field_list = array(
			//なまえ=>タイプ
			'f70ldd_attributes'	=>	'textarea',
			'f70ldd_ng_attributes'	=>	'textarea',
			'f70ldd_attributes_flag'	=>	'checkbox',
			'f70ldd_attributes_anothername'	=>	'text',
			'f70ldd_display_field__region_flag'	=>	'checkbox',
			'f70ldd_display_field__region_anothername'	=>	'text',
			'f70ldd_display_field__company_flag'	=>	'checkbox',
			'f70ldd_display_field__company_anothername'	=>	'text',
			'f70ldd_display_field__fullname_flag'	=>	'checkbox',
			'f70ldd_display_field__fullname_anothername'	=>	'text',
		);
		for ( $i=1; $i<=F70_LDD__FILE_SETS; $i++ ) {
			$field_list['f70ldd_download_file_id_' . $i] = 'file';
			$field_list['f70ldd_download_thumbnail_id_' . $i] = 'file';
		}
		
		//保存(タイプ別に処理違い)
		foreach ( $field_list as $name => $type ) {
			if ( isset($_POST[$name]) ) {
				if ( $type == 'textarea' ) {
					//textareaは改行を::に置き換える
					$data = sanitize_text_field( $this->textarea_replace_break( $_POST[$name]) );
				} else {
					$data = sanitize_text_field( $_POST[$name] );
				}
				
				update_post_meta( $post_id, $name, $data );
				
			} else {
				if ( $type = 'checkbox' ) {
					delete_post_meta( $post_id, $name );
				}
			}
		}
	}
	
	
	
	//-------metaboxなかみ
	/**
	* Render Meta Box content.
	*
	* @param WP_Post $post The post object.
	*/
	public function render_meta_box_shortcode( $post ) {
		echo '[f70ldd_entry_form form_id="' . $post->ID . '"]';
	}
	public function render_meta_box_form_settings( $post ) {
		wp_nonce_field( 'f70ldd_edit_document', 'f70ldd_edit_document_nonce' );
		$this->input_form_attribute_line();
		$this->input_form_attribute_list();
		$this->input_form_attribute_ng_list();
		$this->input_form_display_fields();
	}
	public function render_meta_box_email_settings( $post ) {
	}
	public function render_meta_box_download_settings( $post ) {
		$this->input_form_download_files();
	}
	
	
	
	
	
	//-------フォームパーツ
	
	public function input_form_attribute_list(){
		//属性リスト
		global $post;
		$val = get_post_meta( $post->ID, 'f70ldd_attributes', true );
		if ( !empty($val) ) {
			$val = $this->textarea_add_break( $val );
		}
		echo '<div class="f70_editor_form_area attributes">'
			. '<p class="title">' . __( 'Attributes', 'f70-lead-document-download' ) . '</p>'//属性リスト
			.'<textarea name="f70ldd_attributes" id="f70ldd_attributes" rows="8">' . $val . '</textarea>'
			. '</div>';
	}
	
	public function input_form_attribute_ng_list(){
		//NG属性
		global $post;
		$val = get_post_meta( $post->ID, 'f70ldd_ng_attributes', true );
		if ( !empty($val) ) {
			$val = $this->textarea_add_break( $val );
		}
		echo '<div class="f70_editor_form_area ng_attributes">'
			. '<p class="title">' . __( 'NG Attributes', 'f70-lead-document-download' ) . '</p>'//NG属性リスト
			. '<textarea name="f70ldd_ng_attributes" id="f70ldd_ng_attributes" rows="3">' . $val . '</textarea>'
			. '</div>';
	}
	
	public function input_form_attribute_line(){
		//属性の別名&表示フラグ
		global $post;
		$val_flag = get_post_meta( $post->ID, 'f70ldd_attributes_flag', true );
		$val_anothername = get_post_meta( $post->ID, 'f70ldd_attributes_anothername', true );
		
		global $pagenow;
		if ( $pagenow === 'post-new.php' ) {
			$val_flag = 1;
		}
		
		if ( $val_flag == 1 ) {
			$checked = ' checked';
		} else {
			$checked = '';
		}
		
		echo '<div class="f70_editor_form_area ng_attributes">'
			. '<p class="title">' . __( 'Display Attributes', 'f70-lead-document-download' ) . '</p>';//属性の表示
		
		echo '<div class="f70ldd_form_row attribute_line">';
		echo '<span class="check"><label><input type="checkbox" name="f70ldd_attributes_flag" value="1"' . $checked . '>' . __( 'Display', 'f70-lead-document-download' ) . '</label></span>&nbsp;&nbsp;&nbsp;';//表示する
		echo '<span class="anothername"><label>' . __( 'Change label', 'f70-lead-document-download' )  //項目名を変更
			. ' : <input type="text" name="f70ldd_attributes_anothername" value="'. $val_anothername .'"></label></span>';
		echo '</div>';
		echo '</div>';
	}
	
	public function input_form_display_fields() {
		//入力させる項目
		$array = f70LddFunctions::default_inputs();
		global $post;
		
		echo '<div class="f70_editor_form_area display_fields">'
			. '<p class="title">' . __( 'Input items', 'f70-lead-document-download' ) . '</p>';//入力項目
		
		foreach( $array as $key => $name ){
			/*フィールド名
			f70ldd_display_field_
			f70ldd_display_field__region_flag
			f70ldd_display_field__region_anothername
			*/
			
			$var_flag = get_post_meta( $post->ID, 'f70ldd_display_field__' . $key . '_flag', true );
			$var_anothername = get_post_meta( $post->ID, 'f70ldd_display_field__' . $key . '_anothername', true );
			
			global $pagenow;
			if ( $pagenow === 'post-new.php' ) {
				$var_flag = 1;
			}
			
			if ( $var_flag == 1 ) {
				$checked = ' checked';
			} else {
				$checked = '';
			}
			echo '<div class="f70ldd_form_row ' . $key . '">';
			echo '<span class="label">' . $name . '</span>';
			echo '<span class="check"><label><input type="checkbox" name="f70ldd_display_field__' . $key . '_flag" value="1"' . $checked . '>' . __( 'Display', 'f70-lead-document-download' ) . '</label></span>';
			echo '<span class="anothername"><label>' . __( 'Change label', 'f70-lead-document-download' ) . ' : <input type="text" name="f70ldd_display_field__' . $key . '_anothername" value="'. $var_anothername .'"></label></span>';
			echo '</div>';
		}
		
		echo '</div>';
		
	}
	
	
	public function input_form_download_files() {
		//ファイル&サムネイルの登録
		global $post;
		
		echo '<div class="f70_editor_form_area files">';
		
		for ( $i = 1; $i <= F70_LDD__FILE_SETS; $i++ ) {
			//file
			$attachment_id_file = get_post_meta( $post->ID, 'f70ldd_download_file_id_' . $i, true );
			
			if( !empty( $attachment_id_file ) ) {
				$file_path = get_attached_file( $attachment_id_file );
				$file_name = basename( get_attached_file( $attachment_id_file ) );
				$file_url = wp_get_attachment_url( $attachment_id_file );
			} else {
				$file_path = '';
				$file_name = '';
				$file_url = '';
			}
			//thumbnail
			$attachment_id_thumb = get_post_meta( $post->ID, 'f70ldd_download_thumbnail_id_' . $i, true );
			if ( !empty( $attachment_id_thumb ) ) {
				$thumbnail_url = wp_get_attachment_url( $attachment_id_thumb );
				$thumb_img_tag = '<img src="' . $thumbnail_url . '">';
			} else {
				$thumbnail_url = '';
				
				$thumb_img_tag = '';
			}
			
			echo '<div class="f70ldd_download_file_field f70ldd_form_row" id="f70ldd_download_file_field_' . $i . '">'
				
			. '<p class="title">' . __( 'File', 'f70-lead-document-download' ) . ' ' . $i . '</p>'
				//file
				. '<div class="file">'
				
					. '<input class="f70ldd_filelink_' . $i . '" type="text" size="36" value="' . $file_url . '" readonly>'
					. '<input class="f70ldd_upload_button button" type="button" value="Upload Menu" data-row-num="' . $i . '">'
					. '<input class="f70ldd_delete_button button" type="button" value="Delete" data-row-num="' . $i . '" data-area="file">'
					. '<input id="f70ldd_download_file_id_' . $i . '" name="f70ldd_download_file_id_'.$i.'" type="hidden" value="' . $attachment_id_file . '">'
					. '<br><span>' . $file_name . '</span>'
				
				. '</div>'
				
				//thumbnail
				. '<div class="thumbnail">'
					
					. '<div id="thumbnail_preview_' . $i . '" class="thumbnail_preview">' . $thumb_img_tag . '</div>'
					. '<input class="f70ldd_upload_thumbnail_button button" type="button" value="Upload Thumbnail"  data-row-num="' . $i . '">'
					. '<input class="f70ldd_delete_button button" type="button" value="Delete" data-row-num="' . $i . '" data-area="thumbnail">'
					. '<input id="f70ldd_download_thumbnail_id_' . $i . '" name="f70ldd_download_thumbnail_id_'.$i.'" type="hidden" value="' . $attachment_id_thumb . '">'
					
					
				. '</div>'
				
				
				. '</div>';
		}
		
		echo '</div>';
	}
	
	
	
	//テキストエリアのデータ保存用 改行をつけたり戻したり
	public function textarea_replace_break($str) {
		$ret = '';
		$array = explode( "\n", $str );
		foreach ( $array as $line ) {
			$trimed = trim( $line );
			if ( $trimed ) {
				$ret .= $trimed . '::';
			}
		}
		$ret = rtrim($ret, '::');
		return $ret;
	}
	public function textarea_add_break($str) {
		$ret = '';
		$array = explode( '::', $str );
		foreach ( $array as $line ) {
			$trimed = trim( $line );
			if ( $trimed ) {
				$ret .= $trimed . "\n";
			}
		}
		$ret = rtrim($ret);
		return $ret;
	}
	
//----
}
}