<?php
if( !class_exists( 'f70LddFunctions' ) ){
class f70LddFunctions{
	
	private $entry_page_id;
	public function __construct() {
		
	}
	
	static public function make_dlkey( $length ){
		//キーの発行
		$characters = '1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$str = substr( str_shuffle( $characters ), 0, $length );
		return $str;
	}
	
	public static function get_form_settings( $post_id = '' ){
		//フォームの設定を取得
		if( empty( $post_id ) ){
			return;
		}
		$custom_fields = get_post_custom( $post_id );
		$form_settings = array();
		foreach ( $custom_fields as $key => $array ){
			if ( strpos($key,'f70ldd_') === 0) {
				$key_s = str_replace('f70ldd_', '', $key);
				$form_settings[$key_s] = $array[0];
			}
		}
		
		//属性のリスト化
		if( !empty( $form_settings['attributes'] ) ) {
			$att_list = explode('::', $form_settings['attributes']);
			$form_settings['attribute_list'] = $att_list;
		}
		if( !empty( $form_settings['ng_attributes'] ) ) {
			$att_list = explode('::', $form_settings['ng_attributes']);
			$form_settings['ng_attribute_list'] = $att_list;
		}
		
		//入力フォームのリスト化//必要なものだけ
		$input_text_forms = array();
		$keys = self::default_inputs();
		foreach ( $keys as $key => $name ) {
			$array = array(
				'flag'	=> '',
				'anothername'	=>	'',
			);
			if( !empty( $form_settings['display_field__' . $key . '_flag'] ) ) {
				$array['flag'] = $form_settings['display_field__' . $key . '_flag'];
			}else{
				continue;
			}
			if( !empty( $form_settings['display_field__' . $key . '_anothername'] ) ) {
				$array['label'] = $form_settings['display_field__' . $key . '_anothername'];
			}else{
				$array['label'] = $name;
			}
			$input_text_forms[$key] = $array;
		}
		$form_settings['input_text_forms'] = $input_text_forms;
		
		$form_settings['title'] = get_the_title( $post_id );
		
		return $form_settings;
	}
	
	
	public static function default_inputs() {
		return array(
			'region'	=>	__( 'Your Location', 'f70-lead-document-download' ), //'地域',
			'company'	=>	__( 'Company', 'f70-lead-document-download' ), //'社名',
			'fullname'	=>	__( 'Full Name', 'f70-lead-document-download' ), //'氏名',
		);
	}
	
	
	
//----
}
}
?>