<?php
//アップロード先ディレクトリ変更、保護
if( !class_exists( 'f70LddUploadDirectory' ) ){
class f70LddUploadDirectory{
	
	public function __construct() {
		add_action( 'admin_init', array( $this, 'change_upload_dir' ));
		add_action( 'admin_init', array( $this, 'create_protection_files' ));//ディレクトリと保護ファイルの作成
	}
	
	//アップロード先調整
	public function change_upload_dir() {
		
		global $pagenow;
		//error_log( print_r( 'pagenow->' . $pagenow, true ) );
		
		if(
			!empty( $_SERVER[ 'HTTP_REFERER' ] )
			&& ( $pagenow === 'admin-ajax.php' || $pagenow === 'async-upload.php' )
		) {
			$referrer = parse_url( $_SERVER[ 'HTTP_REFERER' ] );
			if( !empty( $referrer['query'] ) ) {
				parse_str( $referrer['query'], $queries );
			}
			//error_log( print_r( $queries, true ) );
			if(
				!empty( $queries[ 'post' ] )
				&& F70_LDD__POST_TYPE == get_post_type( $queries[ 'post' ] )
			) {
				add_filter( 'upload_dir', array( $this, 'set_upload_dir' ) );
			}
		}
		//error_log( print_r( wp_upload_dir(), true ) );
	}
	
	
	
	public function set_upload_dir( $upload ) {
		//アップロード先ディレクトリ変更
		$subdir_name = '/f70ldd';
		
		$path = $upload['basedir'] . $subdir_name;
		
		$upload[ 'path' ] = $path;
		$upload[ 'subdir' ] = $subdir_name;
		$upload[ 'url' ] = $upload[ 'baseurl' ] . $upload[ 'subdir' ];
		
		return $upload;
	}
	
	
	
	public function create_protection_files() {
		//保護ファイルの作成
		
		$wp_upload_dir = wp_upload_dir();
		$f70ldd_upload_dir = $wp_upload_dir['basedir'] . '/f70ldd';
		
		if ( !file_exists( $f70ldd_upload_dir ) ) {
			wp_mkdir_p( $f70ldd_upload_dir );
		}
		
		$htaccess_path = $f70ldd_upload_dir . '/.htaccess';
		$htaccess_rules = $this->htaccess_rules();
		if ( file_exists( $htaccess_path ) ) {
			if ( $this->htaccess_remake_condition( $htaccess_path ) && wp_is_writable( $f70ldd_upload_dir ) ) {
				@file_put_contents( $htaccess_path,  $htaccess_rules );
			}
		} elseif ( wp_is_writable( $f70ldd_upload_dir ) ) {
			@file_put_contents( $htaccess_path,  $htaccess_rules );
		}
		
		$index_php_path = $f70ldd_upload_dir . '/index.php';
		if ( ! file_exists( $index_php_path ) && wp_is_writable( $f70ldd_upload_dir ) ) {
			@file_put_contents( $index_php_path, '<?php' . PHP_EOL . '// Silence is golden.' );
		}
	}
	
	
	public function htaccess_rules() {
		//.htaccessの中身
		$protected_filetypes = array( 'pdf', 'zip' );
		$rules = 'SetEnvIf Referer "^' . home_url() .'" thissite' . "\n";
		$rules .= "<FilesMatch '\.(" . implode( '|', $protected_filetypes ) . ")$'>\n";
			$rules .= "Order Deny,Allow\n";
			$rules .= "Deny from all\n";
			$rules .= "Allow from env=thissite\n";
		$rules .= "</FilesMatch>\n";
		
		return $rules;
	}
	
	static function htaccess_remake_condition( $htaccess_path ) {
		//.htaccessを書き換える条件
		if ( file_exists( $htaccess_path ) ) {
			$contents = @file_get_contents( $htaccess_path );
			
			//サイトURLが入ってない（書き換えられたなど）
			$pos = strpos( $contents, home_url() );
			if ( $pos === false ) {
				return true;
			}
			
		}
		return false;
	}
	
//----
}
}